﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Report.aspx.cs" Inherits="PBIWebApp._Default" %>
<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">

    <!-- Sign in -->
    <div><h1 style="border-bottom:solid; border-bottom-color: silver">Power BI: Embed a report</h1>
        <asp:Panel ID="signinPanel" runat="server" Visible="true">     

            <asp:Panel ID="signInStatus" runat="server">
            <table>
            <tr>
                <td style="height: 20px"><b>Signed in as:</b></td>
            </tr>
            <tr>
                <td><asp:Label ID="userLabel" runat="server"></asp:Label></td>
            </tr>
            <tr>
                <td><b>Access Token:</b></td>
            </tr>
            <tr>
                <td><asp:TextBox ID="accessTokenTextbox" runat="server" Width="586px"></asp:TextBox></td>
            </tr>

            </table>
                </asp:Panel>
        </asp:Panel> 
    </div>

        <!-- Get dashboards -->


    <!-- Get datasets -->


    <!-- Get Reports -->
    <div> 
        <asp:Panel ID="PanelReports" runat="server" Visible="true">
            <p><b class="step">Step 1</b>: Get reports from your account.</p>
            <table>

            <tr>
                <td><asp:Button ID="Button2" runat="server" OnClick="getReportsButton_Click" Text="Get Reports" /></td>
            </tr>
            <tr>  
                <td><asp:TextBox ID="tb_reportsResult" runat="server" Height="200px" Width="586px" TextMode="MultiLine" Wrap="False"></asp:TextBox></td>
            </tr>

        </table>
        </asp:Panel>
    </div>
      

        <!-- Embed Report-->
    <div> 
        <asp:Panel ID="PanelEmbedTile" runat="server" Visible="true">
            <p><b class="step">Step 2</b>: Embed a report</p>
            <table>
                <tr><td>Enter an embed url for a report from Step 1 (starts with https://):
                    <input type="text" id="tb_EmbedURL" />
                    <%--<asp:TextBox ID="tb_EmbedURL" TextMode="SingleLine" runat="server" Wrap="false"></asp:TextBox></td></tr>--%>

            <tr>
                <td><%--<asp:Button ID="bEmbedTileAction" runat="server" Text="Embed Tile" />--%>
                    <input type="button" id="bEmbedReportAction" value="Embed Report" />
                </td>
            </tr>
                <tr>
                    <td>
                        <iframe ID="iFrameEmbedReport" src="" height="1080px" width="1280px" frameborder="0" seamless></iframe>
                    </td>
                </tr>
            <tr>  
                <%--<td><asp:TextBox ID="TextBox2" runat="server" Height="200px" Width="1024px" TextMode="MultiLine" Wrap="False"></asp:TextBox></td>--%>
            </tr>

        </table>
        </asp:Panel>
            

    </div>
   <script type="text/javascript">

        window.onload = function () {
            // client side click to embed a selected tile.
            //var el = document.getElementById("MainContent_bEmbedTileAction");
            var el = document.getElementById("bEmbedReportAction");
                if (el.addEventListener) {
                    el.addEventListener("click", updateEmbedReport, false);
                } else {
                    el.attachEvent('onclick', updateEmbedReport);
                }

            // listen for message to receive tile click mesages.
            //if (window.addEventListener) {
            //    window.addEventListener("message", receiveMessage, false);
            //} else {
            //    window.attachEvent("onmessage", receiveMessage);
            //}

            // handle server side post backs, optimize for reload scenarios
            // show embedded tile if all fields were filled in.
            var accessToken = '<%=Session["authResult"]==null? null: ((Microsoft.IdentityModel.Clients.ActiveDirectory.AuthenticationResult)Session["authResult"]).AccessToken%>';
            //if(null !== accessTokenElement){
            //    var accessToken = accessTokenElement.value;
                if ("" !== accessToken) updateEmbedReport();
            //}
        };

        // determine how the click action behaves.
        //var drillMode = "drillThrough"; // opens the report/q&a question the tile was pinned from;
        //var drillMode = "openSource"; // opens the dashboard the tile is on.
        var width = 500;
        var height = 500;

        // The embedded tile posts message for click to parent window.  listen and handle as appropriate
        //function receiveMessage(event)
        //{
        //    if (event.data) {
        //        try {
        //            messageData = JSON.parse(event.data);
        //            if (messageData.event === "tileClicked") {
        //                if (drillMode === "drillThrough")
        //                    window.open(messageData.navigationUrl);
        //                else if (drillMode === "openSource")
        //                {
        //                    iFrameSrc = document.getElementById(event.srcElement.iframe.id).src;
        //                    var parts = iFrameSrc.split("dashboardId=");
        //                    var slices = parts[1].split("&");
        //                    var dashboardId = slices[0];

        //                    urlVal = "https://app.powerbi.com/dashboards/{0}";
        //                    urlVal = urlVal.replace("{0}", dashboardId);

        //                    window.open(urlVal);
        //                }
        //            }
        //            else if (messageData.event === "tileLoaded") {
        //                //cache tile data.
        //                var a = messageData.event;
        //            }
        //        }
        //        catch (e) {
        //            // do something smart
        //        }
        //    }
        //}

        // update embed tile
        function updateEmbedReport() {

            // check if the embed url was selected
            //var embedTileUrl = document.getElementById('MainContent_tb_EmbedURL').value;
            var embedReportUrl = document.getElementById('tb_EmbedURL').value;
            if ("" === embedReportUrl) return;

            iframe = document.getElementById('iFrameEmbedReport');
            //var urlWithFilter = baseurl + "&$filter=Cars/car eq 'fiesta'";
            //var urlWithFilter = baseurl + "&filter=Overview/DayOfWeek eq 'Sunday'";
            //var url = valB ? urlWithFilter : baseurl;
            iframe.src = embedReportUrl;
            iframe.onload = postActionLoadReport;

        }

        
        // post the auth token to the iFrame. 
        function postActionLoadReport() {

            // get the access token.
            accessToken = '<%=Session["authResult"]==null? null: ((Microsoft.IdentityModel.Clients.ActiveDirectory.AuthenticationResult)Session["authResult"]).AccessToken%>';
            // return if no access token
            if ("" === accessToken) return;

            var h = height;
            var w = width; 

            // construct the push message structure
            var m = { action: "loadReport", accessToken: accessToken};
            message = JSON.stringify(m);

            // push the message.
            iframe = document.getElementById('iFrameEmbedReport');
            iframe.contentWindow.postMessage(message, "*");;
        }

    </script>

</asp:Content>
